/**********************************************************************
 * Copyright (c) 2005 Scapa Technologies Limited and others
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * Scapa Technologies Limited - Initial API and implementation
 **********************************************************************/

package org.eclipse.stp.b2j.core.jengine.internal.multiplex;


import java.io.ByteArrayOutputStream;

/**
 * @author amiguel
 * 
 * A ByteArrayOutputStream extension which allows access to the uncloned
 * data underneath.
 * 
 * WARNING - buf.length is not necessarily the extent of the underlying data,
 * bout.size() will return the correct extent of valid data in the underlying array.
 */
public class OpenByteArrayOutputStream extends ByteArrayOutputStream {
	public byte[] getByteArray() {
		return buf;	
	}
}